<template>
  <ModalBg>
    <ModalSelectImage @select-image="selectImage" />
  </ModalBg>
  <section class="content">
    <h1 class="text-red-400 text-lg font-semibold capitalize block pb-5">
      create product
    </h1>
    <form class="py-5 w-[600px] flex flex-col gap-y-5" ref="productForm">
      <TextInput
        label="Title"
        v-model="form.title"
        @input="validation('title')"
        :error="$v.title.$errors?.[0]?.$message.toString()"
      />
      <TextInput
        label="Description"
        is-textarea
        v-model="form.description"
        @input="validation('description')"
        :error="$v.description.$errors?.[0]?.$message.toString()"
      />
      <TextInput
        label="Count"
        v-model.number="form.count"
        type="number"
        @input="validation('count')"
        :error="$v.count.$errors?.[0]?.$message.toString()"
      />
      <TextInput
        label="Price"
        v-model.number="form.price"
        type="number"
        @input="validation('price')"
        :error="$v.price.$errors?.[0]?.$message.toString()"
      />
    </form>
    <ImageSelect
      :image-url="getImgSrc(selectedImage)"
      @click="openSelectImageModal"
    />
    <div class="py-10 flex gap-x-5 justify-start">
      <button class="btn" @click="submitForm">Send product</button>
      <button class="btn" @click="refreshForm">Refresh from</button>
    </div>
  </section>
</template>

<script setup lang="ts">
import { useVuelidate } from "@vuelidate/core";
import { required, minLength, minValue } from "@vuelidate/validators";
import { getImgSrc } from "@/helpers/images";

import { Image } from "@prisma/client";
import { ImagesStore } from "@/stores/images";
import { useModalStore } from "@/stores/modal";

const { GetImages } = ImagesStore();
const { OpenModal } = useModalStore();

const rules = computed(() => ({
  title: {
    required,
    minLength: minLength(3),
  },
  description: {
    required,
    minLength: minLength(3),
  },
  price: {
    required,
    minValue: minValue(1),
  },
  count: {
    required,
    minValue: minValue(0),
  },
}));

const form = reactive({
  title: "",
  description: "",
  price: "",
  count: "",
  avatar: "",
});

const $v = useVuelidate(rules, form);

const validation = (inputName: string) => {
  $v.value[inputName].$touch();
};

const openSelectImageModal = async () => {
  await GetImages();
  OpenModal();
};

const selectedImage = ref<Image>();
const selectImage = (image: Image) => {
  selectedImage.value = image;
  form.avatar = image.id;
};

const submitForm = () => {
  $v.value.$touch();
  const canSubmit = Object.values(form).every((e) => e);
  const formIsValid = !$v.value.$invalid;
  if (canSubmit && formIsValid) {
    sendProduct();
  }
};

const refreshForm = () => {
  const keys = Object.keys(form);
  keys.forEach((key: string) => {
    // галімий TS не приймає form[key] тому треба городити ось таку фігню form[key as keyof typeof form]
    form[key as keyof typeof form] = "";
  });
  selectedImage.value = undefined;
  $v.value.$reset();
};

const sendProduct = async () => {
  try {
    await $fetch("/api/product/create", {
      method: "post",
      body: form,
    });
    refreshForm();
  } catch (error: any) {
    console.log(error);
  }
};
</script>

